//
// Created by robin on 1/10/18.
//

#ifndef QDNSAGG_RESOURCERECORD_H
#define QDNSAGG_RESOURCERECORD_H

#include <qplatformdefs.h>
#include <QByteArray>
#include <QDataStream>

namespace QDns
{
    namespace Base
    {
        class QDnsResourceRecord
        {
        public:
            QDnsResourceRecord();

            static QDnsResourceRecord parse(const QByteArray &packetData, quint32 pos);

            static QDnsResourceRecord parse(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray serialize() const;

            void serialize(QDataStream &dataStream) const;

            bool isValid() const;

            const QString &getName() const;

            void setName(const QString &name);

            quint16 getType() const;

            void setType(quint16 type);

            quint16 getClass() const;

            void setClass(quint16 aClass);

            quint32 getTtl() const;

            void setTtl(quint32 ttl);

            const QByteArray &getData() const;

            void setData(const QByteArray &data);

        private:
            bool m_isValid;

            QString m_name;
            quint16 m_type;
            quint16 m_class;
            quint32 m_ttl;
            QByteArray m_data;
        };
    }
}

#endif //QDNSAGG_RESOURCERECORD_H
